
================================================================
aflr2c RELEASE NOTES: 11/01/23 RELEASE VERSION 9.17.6
================================================================

Enhancements/ Additions:
------------------------

* Added capability to convert a 2D planar mesh to an axisymmetric
  or stacked plane 3D volume mesh with tet-elements. Parameters
  that control this capability include mesh_3d, nplane, dang,
  and dz.

Bugs Fixed:
-----------

* 

================================================================
aflr2c RELEASE NOTES: 09/09/23 RELEASE VERSION 9.17.3
================================================================

Enhancements/ Additions:
------------------------

* Revised AFLR2C integration routines and added LIB aflr2c_main.

* Added grid quality information capability using LIB ug2_qchk.

Bugs Fixed:
-----------

* 


================================================================
aflr2c RELEASE NOTES: 07/16/23 RELEASE VERSION 9.14.7
================================================================

Enhancements/ Additions:
------------------------

* Removed test mode passes.

Bugs Fixed:
-----------

* 

================================================================
aflr2c RELEASE NOTES: 11/20/22 RELEASE VERSION 9.14.6
================================================================

Enhancements/ Additions:
------------------------

* Changed all sprintf calls to snprintf.

Bugs Fixed:
-----------

* 

================================================================
aflr2c RELEASE NOTES: 10/12/22 RELEASE VERSION 9.14.5
================================================================

Enhancements/ Additions:
------------------------

* Changes for compatibility with UG library.

Bugs Fixed:
-----------

* 

================================================================
aflr2c RELEASE NOTES: 08/29/22 RELEASE VERSION 9.14.4
================================================================

Enhancements/ Additions:
------------------------

* Updated use of boundary edge ID during boundary recovery.

Bugs Fixed:
-----------

* 

================================================================
aflr2c RELEASE NOTES: 02/08/21 RELEASE VERSION 9.13.17
================================================================

Enhancements/ Additions:
------------------------

* Changes for compatibility with UG library routines and parameter
  initialization.

Bugs Fixed:
-----------

* 

================================================================
aflr3 RELEASE NOTES: 02/06/21 RELEASE VERSION 16.31.3
================================================================

Enhancements/ Additions:
------------------------

* Changes for compatibility with UG library routines and parameter
  initialization.

Bugs Fixed:
-----------

* 

================================================================
aflr3 RELEASE NOTES: 01/20/21 RELEASE VERSION 16.31.1
================================================================

Enhancements/ Additions:
------------------------

* Modified integration API routine aflr3_tet_mesh routine in file
  aflr3_tet_grid.

Bugs Fixed:
-----------

* 

Known Issues
------------

* Interior core mesh (ICE) mode -ice can require a very large
  amount of memory temporarily as well as use of the 64-bit int
  version, aflr3_l.

================================================================
aflr3 RELEASE NOTES: 11/25/20 RELEASE VERSION 16.30.17
================================================================

Enhancements/ Additions:
------------------------

* Added option to output a skew biased quality measure using the
  new parameter m_qvrrchk=1. By default this output is off.

Bugs Fixed:
-----------

* 

Known Issues
------------

* Interior core mesh (ICE) mode -ice can require a very large
  amount of memory temporarily as well as use of the 64-bit int
  version, aflr3_l.

================================================================
aflr3 RELEASE NOTES: 10/10/20 RELEASE VERSION 16.30.16
================================================================

Enhancements/ Additions:
------------------------

* Added API interface aflr3_tet_gen which is similar to aflr3_tet_grid.
  Interior meshing and boundary face reconnection with the new API
  are no longer options (an interior mesh is always generated and
  boundary faces are never reconnected.

Bugs Fixed:
-----------

* Corrected an issue that resulted in incorrect termination of BL
  advancement. The issue only occurred if the BL generating surface
  was nearby a surface that intersects the BL region. In those cases
  proposed BL nodes could be rejected even though they were not
  visible to the surface that intersects the BL region.

Known Issues
------------

* Interior core mesh (ICE) mode -ice can require a very large
  amount of memory temporarily as well as use of the 64-bit int
  version, aflr3_l.

================================================================
aflr3 RELEASE NOTES: 07/03/19 RELEASE VERSION 16.30.1
================================================================

Enhancements/ Additions:
------------------------

* Added capability to time CPU usage of various routines. Set
  parameter cpu_timer=1 to activate.

Bugs Fixed:
-----------

* 

Known Issues
------------

* Interior core mesh (ICE) mode -ice can require a very large
  amount of memory temporarily as well as use of the 64-bit int
  version, aflr3_l.

================================================================
aflr3 RELEASE NOTES: 05/28/19 RELEASE VERSION 16.29.5
================================================================

Enhancements/ Additions:
------------------------

* Changed default value for candidate to node checking flag, mfchkn,
  to be on by default. This change eliminates the need for small edge
  deletion in quality .

* Modified slightly the checking of new candidate points to existing
  nodes and to each other.

* Changed default value for small edge deletion flag, mdse, to
  be off by default. Note that the previous two changes enable this
  change.

Bugs Fixed:
-----------

* 

Known Issues
------------

* Interior core mesh (ICE) mode -ice can require a very large
  amount of memory temporarily as well as use of the 64-bit int
  version, aflr3_l.

================================================================
aflr3 RELEASE NOTES: 01/31/19 RELEASE VERSION 16.28.5
================================================================

Enhancements/ Additions:
------------------------

* Modified Message_Flag (mmsg) usage for values of 0 (no output)
  and -1 (minimal output).

Bugs Fixed:
-----------

* Corrected possible initialization error.

Known Issues
------------

* Interior core mesh (ICE) mode -ice can require a very large
  amount of memory temporarily as well as use of the 64-bit int
  version, aflr3_l.

================================================================
aflr3 RELEASE NOTES: 10/17/18 RELEASE VERSION 16.27.6
================================================================

Enhancements/ Additions:
------------------------

* Added BL-aspect-ratio scaling to Q quality function.

Bugs Fixed:
-----------

* Corrected memory error in element neighbor volume ratio quality
  functions.

Known Issues
------------

* Interior core mesh (ICE) mode -ice can require a very large
  amount of memory temporarily as well as use of the 64-bit int
  version, aflr3_l.

================================================================
aflr3 RELEASE NOTES: 09/23/18 RELEASE VERSION 16.27.3
================================================================

Enhancements/ Additions:
------------------------

* Added new method for mesh quality checking used during generation
  post-processing. The new method is on by default for non-BL mesh
  generation. During BL mesh generation no quality information is
  generated, as before, since the BL region of the mesh is never
  fully stored in memory. Mesh quality information continues to be
  available in post-processing mode for the completed mesh. As
  before, the -qstat flag is available for quality distributions.
  Post-processing with the new -qchk flag invokes the new method.
  The new method includes information on and checking of element
  angle, volume, minimum edge-length, Q-measure (volume to edge-
  length ratio), and element to neighbor element volume ratio.

Bugs Fixed:
-----------

* Corrected a significant issue during advancing-front point
  placement that allowed nodes to be created with nearly identical 
  locations.

Known Issues
------------

* Interior core mesh (ICE) mode -ice can require a very large
  amount of memory temporarily as well as use of the 64-bit int
  version, aflr3_l. This situation can occur if a domain has
  regions of very small spacing that are located throughout the
  domain such that a bounding-box of the smallest length scales
  would be relatively large. The current version of ICE uses
  full arrays with i-blanking over the entire bounding box for
  each length scale. Future versions will use a more compact
  linked structure that will not have this issue.


================================================================
aflr3 RELEASE NOTES: 08/01/18 RELEASE VERSION 16.25.17
================================================================

Enhancements/ Additions:
------------------------

* Changed mw_bg_func to mw_func.

* Added mw_func_type for UGRID/SFUNC and MESHB/SOLB file types.

* Turned off input surface mesh checking for background grid
  generation only modes (mbackgen=1 and 3).

Bugs Fixed:
-----------

* 

Known Issues
------------

* Interior core mesh (ICE) mode -ice can require a very large
  amount of memory temporarily as well as use of the 64-bit int
  version, aflr3_l. This situation can occur if a domain has
  regions of very small spacing that are located throughout the
  domain such that a bounding-box of the smallest length scales
  would be relatively large. The current version of ICE uses
  full arrays with i-blanking over the entire bounding box for
  each length scale. Future versions will use a more compact
  linked structure that will not have this issue.

================================================================
aflr3 RELEASE NOTES: 06/11/18 RELEASE VERSION 16.25.15
================================================================

Enhancements/ Additions:
------------------------

* Added an option for checking the volume of all 12 possible
  tetrahedral BL elements that could be created for each BL face.
  This also insures full pyramid validity. This option is turned
  on,off with the input parameter mblchkv=1,0 and is on by default.

* Added normal distance checking between BL points and surfaces
  that intersect the BL region (symmetry plane).

* Moved short edge deletion to quality improvement in aflr3_qual.

* Added routine aflr3_gen_bg with reduced API for generating a
  background mesh.

* Added centroid point placement for very low quality elements
  during normal mesh generation. This is intended to correct an
  issue with very simple configurations such as a pipe section
  with uniform spacing wherein long sliver-like elements can be
  formed near the boundary or BL interface.

* Added capability to skip all output when aflr3_grid_generator_i
  is called directly.

* Added capability to return and manage the distribution function,
  metric, and element neighbor connectivity created in
  aflr3_grid_generator_i. The APIs to do so are provided by
  routines aflr3_save_ieliel_free, aflr3_save_ieliel_set, and
  aflr3_save_ieliel_save. See aflr3_save_ieliel.h. The input
  parameter flags to control saving this data are msave_df,
  msave_met, and msave_ieliel.

* Added advancing-point point placement option (mpp=3) to create
  right-angle tet-elements rather than equiangular tet-elements.

* Added metric-aligned metric-orthogonal advancing-front and
  advancing-point point placement.

* Removed explicit sub-domain mode code.

* Modified seeding process for domains with partition boundaries.

* Modified checking of points near partition boundaries.

* Modified quality improvement near partition boundaries.

* Modified removal of field and boundary sliver elements near
  partition boundaries.

* Updated test evaluation function.

* Added lm7 MESH library with full 64-bit int support.

* Turned off local smoothing reduction.

* Modified parameters for edge length multiplier and nearby node
  factor. New parameters are cdff2 and cdfn2. Removed parameters
  nadvpit and cdffinl.

Bugs Fixed:
-----------

* Corrected memory error that could occur during quality grid 
  regeneration QRG. This error usually resulted in a SEGFAULT.

* Added a missing memory free when only checking the input
  boundary surface mesh (-bcheck or mbcheck=1 option).

* Reduced geometry tolerance used for locating points on edges
  and in faces of surfaces that intersect the BL region. This
  eliminates erroneous projections with small BL normal spacing
  along edges very close to the wall.

* Corrected an error in checking points on surfaces that intersect
  the BL region (symmetry plane) that could lead to early
  termination of BL advancement on those surfaces.

Known Issues
------------

* Interior core mesh (ICE) mode -ice can require a very large
  amount of memory temporarily as well as use of the 64-bit int
  version, aflr3_l. This situation can occur if a domain has
  regions of very small spacing that are located throughout the
  domain such that a bounding-box of the smallest length scales
  would be relatively large. The current version of ICE uses
  full arrays with i-blanking over the entire bounding box for
  each length scale. Future versions will use a more compact
  linked structure that will not have this issue.

================================================================
aflr3 RELEASE NOTES: 03/15/17 RELEASE VERSION 16.15.23
================================================================

Enhancements/ Additions:
------------------------

* For Cartesian interior core mode (-ice or m_ice=1) the use of
  of background grid mode (including internal use) was turned off
  for generation of boundary gap regions only.

* For Cartesian interior core mode (-ice or m_ice=1) additional
  checks were added on refinement level differences to limit
  differences between all adjacent elements to one.
  
* For Cartesian interior core mode (-ice or m_ice=1) the boundary
  point checking process was modified to include a growth rate check
  if cdfr_gap_ic is specified. This is only active when df_ic_min
  is specified or there is only one level of refinement. When
  df_ic_min and cdfr_gap_ic are specified and there are multiple
  levels of refinement then the growth rate check is only active
  on the finest level of refinement.

* Removed repeated output of quality grid regeneration QRG heading.

* Moved ice3_split_data routines to UG3 library (removes ANBL3
  dependency on ICE3 library).

* Moved ug_io_split_data routines to UG3 library.

* Revised interior core mesh (ICE) algorithm. These changes
  improve refinement near outer boundaries. Particularly those
  with large regions where the surface is flat and the surface
  normal is in only the x, y, or z coordinate direction. 

* Changes for compatibility with 64-bit integers.

* Modified included angle check for surfaces that intersect the BL region
  to include transparent BL generating surfaces as possible neighbors.

* Added a check that prevents BL nodes from being rejected when they are
  advancing away from another potentially interfering boundary. Previously
  this check could made it appear that the normal distance to the
  potentially interfering boundary was very small.

* Modified the default value for the number of layers to smooth BL normal
  spacing (and thickness) over from 5 layers to 20 layers. This prevents
  element quality degradation when the difference in spacing between
  adjacent BL generating surfaces is up to an order of magnitude. 

* Modified open BL method. With the new method the option flags have changed.
  The new -open2 option is nearly the same as the previous -open option.
  
  -open (or mopen=1) : Generate an open BL region grid for a closed domain.
  With an open BL region the BL grid is generated and the domain is only the
  generated BL region. No isotropic region elements are generated. With a
  closed domain all of the input surfaces are retained and standard boundary
   surface face reorientation is done as needed (same as default).

  -open2 (or mopen=2) : Generate an open BL region grid for an open domain.
  With an open BL region the BL grid is generated and the domain is only the
  generated BL region. No isotropic region elements are generated. With an
  open domain only the input surfaces that are used for BL generation are
  retained and no individual boundary surface face reorientation is done. All
  of the boundary surface faces are assumed to be properly orientated such
  that RH rule ordering points in the direction of BL generation. The only
  possible face reordering is a global reordering using the -revbl (mrevbl=1)
  option. If the input surface grid is a non-closed surface then the BL region
  will be aligned normal to the surface edges. The output grid includes a new
  boundary surface for the exposed surface of the BL region with a boundary
  surface face ID equal to the maximum ID plus 1.

* Reinstated setting of number of BL tet-elements.

Bugs Fixed:
-----------

* Corrected a fatal memory issue if any refinement levels are removed.

* Corrected an issue that is only applicable when the Cartesian
  core option (-ice or m_ice=1). In those cases a possible error
  can occur related to checking elements on refinement level
  interfaces. This can occur with sources that extend to the
  domain boundaries.

Known Issues
------------

* Interior core mesh (ICE) mode -ice can require a very large
  amount of memory temporarily as well as use of the 64-bit int
  version, aflr3_l. This situation can occur if a domain has
  regions of very small spacing that are located throughout the
  domain such that a bounding-box of the smallest length scales
  would be relatively large. The current version of ICE uses
  full arrays with i-blanking over the entire bounding box for
  each length scale. Future versions will use a more compact
  linked structure that will not have this issue.

================================================================
aflr3 RELEASE NOTES: 12/17/16 RELEASE VERSION 16.10.20
================================================================

Enhancements/ Additions:
------------------------

* Moved dftr3_qtb_chk, dftr3_qtb_chk_n, and dftr3_qtb_eval to
  AFLR3C_LIB.

* Made dftr3_src_* routines external and moved them to AFLR3C_LIB.

Bugs Fixed:
-----------


================================================================
aflr3 RELEASE NOTES: 12/07/16 RELEASE VERSION 16.9.19
================================================================

Enhancements/ Additions:
------------------------

* Changes for compatibility with revised ICE3 and UG3 library
  routines.

* Added additional output file for revised ICE3 capability.
  The new file is type SPLIT and contains a list of the hex
  elements that have split quad faces (adjacent element has
  2:1 refined spacing).

* Revised BL element quality checks to omit face angle checks
  if the starting boundary surface mesh is of low quality (or
  was generated with an anisotropic metric adaptation method).

* Revised BL element quality checks to omit element dihedral
  element checks that are dependent upon the initial face angles
  if the starting boundary surface mesh is of low quality (or
  was generated with an anisotropic metric adaptation method).

* Changes for compatibility with revised BL normal vector
  methodology.

* Added most normal normal vector method to normal vector routines.
  The parameter mbv_mode now controls the method for normal vector
  determination.
  If mbv_mode = 1 then use LS method to determine the node normal
  vector that has the minimum deviation with respect to the
  surrounding face normal vectors. This is the default.
  If mbv_mode = 2 then use a most-visible method to determine the
  node normal vector that maximizes the minimum tetrahedral volume
  for the surrounding faces. 
  If mbv_mode = 3 then use a simple averaging method to determine
  the node normal vector. 

* Added determinant tolerance to least-squares normal vector
  algorithm.

* Changes for compatibility with revised DFTR3 & OTB LIBs.

Bugs Fixed:
-----------


================================================================
aflr3 RELEASE NOTES: 10/20/16 RELEASE VERSION 16.4.5
================================================================

Enhancements/ Additions:
------------------------

* Complete revision of interior core mesh (ICE) overall approach.
  If this option (-ice) is specified then the new version will
  generate a Cartesian core with isotropically varying hex size
  dependent upon a background mesh. AFLR3 will automatically
  generate the background mesh if one is not input. The resulting
  mesh has a minimal region of truly unstructured mesh adjacent
  to each surface.

Bugs Fixed:
-----------


================================================================
aflr3 RELEASE NOTES: 10/04/16 RELEASE VERSION 15.18.49
================================================================

Enhancements/ Additions:
------------------------

* Modified element trim/removal for sub-domain mode. This mode is
  under development and not user accessible within AFLR3.

Bugs Fixed:
-----------

================================================================
aflr3 RELEASE NOTES: 08/19/16 RELEASE VERSION 15.17.46
================================================================

Enhancements/ Additions:
------------------------

* Added capability for transparent/embedded surfaces that intersect
  the BL region to have free edges that also intersect the BL
  region.

* Added more accurate determination of node locations along edges
  that intersect the BL region (both between surfaces and free).

* Added capability to specify the case name for the background
  grid and function files independent of the input grid file
  name.

* Added background mesh element neighbor connectivity to API
  for aflr3_grid_generator.

* Added an option to only check the input surface mesh. This
  option is activated by either -bcheck or mbcheck=1.

Bugs Fixed:
-----------


================================================================
aflr3 RELEASE NOTES: 07/28/16 RELEASE VERSION 15.14.36
================================================================

Enhancements/ Additions:
------------------------

* Added option flag -backgen2 to generate a background mesh
  mesh and length-scale data from the input surface mesh and
  then use the background mesh to generate the final volume mesh.
  In the future this will become the default mode and pure
  interpolation will be removed.

* Changes for compatibility with the parallel partitioning code
  SD3. This is under development and not user accessible within
  AFLR3.

Bugs Fixed:
-----------

* 

================================================================
aflr3 RELEASE NOTES: 06/22/16 RELEASE VERSION 15.11.29
================================================================

Enhancements/ Additions:
------------------------

* Changes for compatibility with new method for least-squares
  optimized BL normal vectors.

* Added option flag -backgen to generate and output a background
  mesh (and function file) from the input surface mesh.

Bugs Fixed:
-----------

* Eliminate memory leak with Cartesian core (m_ice=1) option on.

* Corrected an error computing the distance between BL nodes and
  surfaces that intersect the BL region. This error could cause
  boundary recovery to fail due to advancement of the BL outside
  the domain and causing intersection of the BL region with a
  surface that intersects the BL in a region where there should
  be no intersection.

================================================================
aflr3 RELEASE NOTES: 04/07/16 RELEASE VERSION 15.11.22
================================================================

Enhancements/ Additions:
------------------------

* Changes for compatibility with UG3 routine that writes a grid
  file.

* Minor syntax change in if check.

* Modified check for source nodes that are too close to each other.

* Updated internal reduced memory read/write API for the final
  volume grid.

* Combined AFLR3 Lib and AFLR3_API Lib. AFLR3_API Lib is no
  longer separate or used.

Bugs Fixed:
-----------

* Corrected and issue with the boundary face error flag when
  generated a grid with a uniform interior Cartesian core (ICE).

* Corrected an initialization error that could lead to boundary
  node insertion errors or boundary recover errors.

* Corrected an error in always reporting that a closed embedded
  transparent BL generating surface was found whenever there were
  any transparent BL generating surfaces

================================================================
aflr3 RELEASE NOTES: 12/02/15 RELEASE VERSION 15.5.9
================================================================

Enhancements/ Additions:
------------------------

* Added initial beta version of sub-domain mode to be used in
  conjunction with the sub-domain handling program SD3. This
  mode should only be used for testing at this point.

* Added memory allocation limit for the estimated maximum number
  of elements to be no more than 10 times the actual number of
  initial elements.

* Modified length scale reduction with mlsr=1 to improve compatibility
  with boundary specified spacing. This only applies to cases with
  mlsr=1 and very small ratios of body spacing divided to far-field
  or outer domain size.

* Added input parameter lsrcdf to adjust spacing of source points
  created using length scale reduction if mlsr=1.

* Added input parameter lsrlimitm to modify the number of length scale
  reduction passes if mlsr=1.

* Added metric blending capability to surface grid regeneration
  for planar surfaces that intersect the BL region.

Bugs Fixed:
-----------

* Modified procedure to reset standard surfaces from standard to
  BL surfaces if they are adjacent to a BL generating surface.
  The original could set inappropriate surfaces to BL generating
  surfaces.

* Corrected usage of node index for sources when they aren't
  inserted and the node index is set to zero.

* Corrected potential memory usage error with the map for
  elements surrounding a node.

* Added a check for division by zero if the distribution
  function is set to zero prior to setting the initial
  metric for added length scale reduction nodes or boundary recovery
  helper nodes.

* Corrected initialization of metric values when metric blending
  is on.

* Corrected potential issue initializing and checking metric and
  transformation vectors for sources.

================================================================
aflr3 RELEASE NOTES: 09/29/15 RELEASE VERSION 14.24.128
================================================================

Enhancements/ Additions:
------------------------

* Modified 3D interior core mesh code for improved quality and
  more robust group identification.

* Modified glue tolerance for connecting interior core mesh to
  unstructured mesh so that it accounts for any boundary point
  movement required to insert points into the unstructured domain.

* Modified volume calculations and checking so that consistent
  checks are possible.

* Moved pyramid transition routines to AFLR3_LIB.

* Added changes for compatibility with new version of AFLR2.

Bugs Fixed:
-----------

* Corrected an error that ignored sources that should have
  been generated from source type transparent/embedded surfaces
  (those with a Grid BC Flag of 3).

* Corrected error when pyramid transition (mquadp=1) is
  active and quality regeneration phase (QRG) is activated
  (mqrgen=1 and low-quality elements detected).

* Corrected memory free error with pyramid transition.

* Correct error in minimum volume calculations of the local-
  reconnection routines.

================================================================
aflr3 RELEASE NOTES: 06/20/15 RELEASE VERSION 14.19.118
================================================================

Enhancements/ Additions:
------------------------

* Added capability to generate a 3D interior core mesh using the
  ICE3 library.

* Added option flag -quadp to turn on pyramid transition from
  quad faces.

* Added max edge length check to routine that collapses short edges.

* Added complete background grid capability. If a background grid
  is input then it is used for all length scale evaluations. No
  input options are required with a background grid. The executable
  will search for files named input_case_name.back.* for the
  background volume grid and function file. If they exist they
  will be read and data passed to AFLR3. Internal options are set
  if a background grid is passed to AFLR3.

Bugs Fixed:
-----------

* Corrected incorrect script in examples that used the background
  volume grid file as name *.BG.* instead of the correct *.back.*.

* Corrected a memory free error after BL grid generation.

* Modified code so that quad surface faces could exist on non-BL
  generating surfaces and BL generating ones with the -blc3 option
  (pyramid transition from quad faces). Previous versions would
  fail if quads existed on both.

* Corrected tmp data file issue.

================================================================
aflr3 RELEASE NOTES: 01/04/15 RELEASE VERSION 14.15.95
================================================================

Enhancements/ Additions:
------------------------

* Added capability for BL generating embedded/transparent surfaces
  that have non-manifold (multiple) connections between them and
  other embedded/transparent and/or solid surfaces.

* Modified maximum output precision for double data with ASCII files.

* Added use of actual mesh data when calling external evaluation
  initialization routine.

Bugs Fixed:
-----------

* Correct error that prevented use of external sizing evaluation
  routines.
================================================================
aflr3 RELEASE NOTES: 08/17/14 RELEASE VERSION 14.14.82
================================================================

Enhancements/ Additions:
------------------------

* Added capability to regenerate surface grids using the AFLR4
  3D surface generator. This is used to rebuild surfaces that
  intersect BL regions. Previously a planar projection was used
  along with AFLR2 to generate projected 2D grids and re-project
  back to the true surface. That imposed restrictions on
  curvature for an individual surface. Those restrictions are no
  longer valid. Note that AFLR4 uses the input surface grid as
  a discrete definition of the geometry and resulting curvature
  is limited by the input resolution. Also, AFLR4 automatically
  checks for planar surfaces, such as symmetry planes, and uses
  2D generation in those cases.

* Removed input parameter angqprojuv that was used to check if
  surface projection was valid. This check used for each surface
  that intersected the BL region and required regeneration. It is
  not applicable now that AFLR4 surface generation with mapping
  generation is used.

* Modified internal API for surface search (ug3_srchbf) to allow
  for a two-pass algorithm that uses a large tolerance on the
  second pass to find locations that are off the surface and near
  a surface node.

* Added capability for background grid evaluation of all spacing
  related data (isotropic sizing, metric based sizing, transformation
  vector based sizing). However, this is only available in the
  library version. The proper input file specification for the
  executable stand-alone version is in progress and will be released
  soon.

Bugs Fixed:
-----------

* 

================================================================
aflr3 RELEASE NOTES: 06/26/14 RELEASE VERSION 14.12.79
================================================================

Enhancements/ Additions:
------------------------

* Added API argument to specify a method when using an external sizing function.
  The method is specified using the mext_eval input parameter. Note that the
  built-in external sizing function is intended for testing mode only and not
  useful for real applications.

* Added setup to activate external sizing function for rebuild surfaces.

* Added minimum planar surface face angle check. The minimum allowed angle is
  set by angqbfmin.

* Modified element removal after boundary recovery to insure proper
  initialization of connectivity. Added testing output.

* Turned off output messages related to recoverable errors during sub-grid
  regeneration.

* Modified surface normal calculation during boundary recovery point generation.

* Modified transformation vector calculation for normal direction transformation
  during boundary recovery.

* Modified local reconnection optimization criterion checks for improved 
  boundary recovery.

* Added check and error message for potential non-manifold volumes connected
  only at a point or along edges.

* Added call to grid BC reset routine from ANBL3 library so that if it resets
  BCs those are available to the initial surface grid checks that are done in
  AFLR3. This only impacts potential differences in initial checks that occur
  when options -bls, -ints, fints, BL_IDs, Int_IDs, or Fixed_Int_IDs (used be
  ANBL3 reset routine) are used versus BC_IDs and GRID_BC_Flag (used by AFLR3
  reset routine) versus a tags file (used by AFLR3 reset routine).

* Added ability to turn on/off the source and metric related evaluations and
  added usage in quality regeneration.

* Modified determination of the transformation vector and metric values in the
  external sizing function test routines.

* Eliminate majority of output during surface regeneration for surfaces that
  intersect the BL region.

* Changed search flag for projecting BL normals on rebuild surfaces that
  intersect the BL region to prevent search failure on the first pass of BL
  grid generation.

* Revised discontinuity check for turning off least-squares BL normals so that
  is based on an edge discontinuity as defined by the discontinuity angle angbd.

* Modified home BL normals are determined on surfaces that intersect the BL
  region using an assumptions of symmetry.

* Revised nearest nearby node factor so that is based on the BL node related
  factor cdfnbl rather than the field related factor cdfn when checking how
  close a BL node can come to an edge on a surface that intersects the BL
  region.

* Corrected an issue during BL grid generation when fixed surfaces that
  intersect the BL region are used with hex elements and pyramid transition.
  Previously the last BL level on the fixed intersecting surface was terminated
  with that combination of options. They are now handled the same as with split
  face transition.

* Added removal of transparent surfaces that are set to generate an attached BL
  region if an open BL mesh is requested (-open or mopen=1).

* Added reset of BL thickness (deldef=0 or -bldel 0) to the option
  maximum BL thickness option -bldelmax.

* Modified BL global termination parameters. The BL global termination parameter
  mblend now can only be 0 or 1 (on or off). The old option for mblend=2
  essentially behaved the same as mblend=1 except that it ignored the BL
  thickness (and that can be controlled using -bldel or deldef or -bldelmax.
  The maximum normal-direction-aspect-ratio parameter cblmnr now helps control
  global termination and functions in that regard the same as the termination
  maximum normal-direction-aspect-ratio parameter cblnrendmx, which is now
  deleted. Also, changed the name of the termination minimum normal-direction-
  aspect-ratio parameter cblnrendmn to cblmnrmin (and not often varied).

* Added option -no_psdata to set new input parameter PSDATA_File_Flag. This
  option forces AFLR3 not to read the  PSDATA file even if it exists.

Bugs Fixed:
-----------

* Corrected removal (after successful completion) of subgrid FAIL surface grid
  file when subgrid generation mode is used during boundary recovery.

* Corrected an initialization error that could occur after BL grid generation
  with hex elements and pyramid transition along with constrained/fixed boundary
  surfaces.

* Corrected an initialization error that could occur when deleting elements
  outside the domain after boundary recovery.

================================================================
aflr3 RELEASE NOTES: 05/13/14 RELEASE VERSION 14.6.48
================================================================

Enhancements/ Additions:
------------------------

* Added new ARG input argument file type (*.arg) to replace the
  old PARAM input parameter file type (*.par). Old PARAM parameter
  files can still be input. In all cases an argument file is
  saved for rerunning with the same options if the program runs to
  successful completion. See the documentation for more information
  on argument files.

Bugs Fixed:
-----------

* Corrected uninitialized memory usage when splitting large initial
  elements that have large edge lengths and are slivers.

* Corrected memory leak after BL grid generation when using
  pyramid transition from boundary surface quad faces.

================================================================
aflr3 RELEASE NOTES: 04/27/14 RELEASE VERSION 14.5.41
================================================================

Enhancements/ Additions:
------------------------

* Added capability to use program executable arguments that 
  individually are of any length (subject to system limits on the
  overall argument list length of 262144 bytes or characters). If
  they are set internally then there is no limit (other than
  overall system memory limits). This impacts primarily setting
  of input parameter vectors, e.g. ID lists for BCs, spacing for
  specified normal spacing, etc. Note that pathnames are still
  subject to system limits.

* Limited maximum number of layers for SNS mode when transition
  at end of BL region is abrupt.

* Correct and add clarification to some of the help/documentation
  parameter descriptions related to lists (*_IDs related).

* Changed default on use of an external sizing function. This
  option is now always available. Although, it is only useful 
  for testing, unless an external function is created and 
  the executable is compiled with it linked in.

* Modified built-in external sizing function. Added option to
  test metric space based sizing.

Bugs Fixed:
-----------

* Corrected possible memory leak after using pyramid transition
  from boundary surface quad faces.

* Corrected error in reading UG input parameter files.
  Previous 14.x.x versions did not actually set or use any
  of the input parameters read.

* Corrected an error in evaluating xyz coordinates at given
  estimated xyz coordinates. The error could occur if the
  surface was defined as a discrete surface and the given
  coordinates exactly matched a those of at a point on the 
  discrete definition. This issue could occur with rebuild
  surfaces that intersect the BL region.

* Correct setting reconnection flag from a TAGS data file.

* Correct memory leak with use of a TAGS data file.

* Correct memory leak with use of a vector input parameter.

* Correct potential uninitialized variable use. This change 
  primarily impacts use of an external sizing function.

================================================================
aflr3 RELEASE NOTES: 02/25/14 RELEASE VERSION 14.1.31
================================================================

Enhancements/ Additions:
------------------------

* Convert to new ug parameter structure scheme and eliminate
  use of Error_Message.

* Modified usage of mquadp parameter option so that only the
  option is now either on or off.

* Added option -blc3 that combines mquadp=1 and -blc2.

* Added r8 and lr8 UNFORMATTED FORTRAN capability to internal
  out-of-core UGRID files.

* The conversion to the new ug parameter structure scheme includes
  the following input flag/parameter changes.

================================================================================
The following option flags are no longer available and there are currently no
equivalent parameters.

-help_ug_io		: list full documentation on UG_IO input/output files
-doc			: view HTML documentation
-host host_name		: run on remote host named "host_name"
-w			: send output to a new X-window using xterm
-dev			: use executable in current directory with standard name
-diag			: list executable location and library dependencies
-test			: run script and only echo the executable command
-dbx			: run executable using dbx debugger
-gdb			: run executable using gdb debugger
-ddd			: run executable using ddd debugger
-insight		: run executable using insight debugger
-debug			: use debug version of executable, aflr3_g.exe
-purify			: use purify version of executable, aflr3.exe.pure
-prof			: use gprof version of executable, aflr3_p.exe
-64			: use 64-bit executable
-blrend end_growth_ratio: set BL normal spacing ending growth rate
-mp np			: use multi-pass multi-partition mode
-mpe ne			: use multi-pass multi-partition mode
-np n			: use parallel mode

Note that -blrend should have been removed from aflr3 bin script when parameters
cdfblrend and dcdfrblend were removed in 08/12/10 RELEASE VERSION 12.8.9).
Note that all of the parallel processing option flags and parameters, -mp, -mpe,
and -np are now off and will be added back when that capability is revised.

The following option flags are no longer available. However, they currently have
equivalent parameters. They are listed with their original description and the
new equivalent parameter options.

-fast			: very fast (lower quality) isotropic grid generation
current equivalent	: mrec4=0 mrecm=1 nqual=1 mqrgen=0

-minout			: generate minimum output messages
current equivalent	: Message_Flag=0

-mmr_rec		: use MAX-MIN-Rratio local-reconnection criterion
current equivalent	: mrecm=3 mrecqm=3

-mma_rec		: use MIN-MAX-Angle local-reconnection criterion
current equivalent	: mrecm=2 mrecqm=2

-trsrc			: use anisotropic transformation sources
current equivalent	: -trsrc_ng

-trsrc_grow		: use anisotropic transformation sources with growth
current equivalent	: -trsrc

-blints i1,i2,...,iN	: set intersecting surface BC on surfaces i1,i2,...,iN
current equivalent	: -ints i1,i2,...,iN

-blfints i1,i2,...,iN	: set fixed surface BC on surfaces i1,i2,...,iN
current equivalent	: -fints i1,i2,...,iN

-du du_value		: set laminar BL velocity increment for normal spacing
current equivalent	: dup=du_value

-du+ du+_value		: set turbulent BL velocity increment for normal spacing
current equivalent	: dup=du+_value

-vdir u v w		: set the flow direction for assumed BL velocity profile
current equivalent	: vx=u vy=v vz=w

-no_blauto		: do not automatically calculate BL growth parameters
current equivalent	: mblauto=0 (default)

-slints i1,i2,...,iN	: set intersecting surface BC on surfaces i1,i2,...,iN
current equivalent	: -ints i1,i2,...,iN

-slfints i1,i2,...,iN	: set fixed surface BC on surfaces i1,i2,...,iN
current equivalent	: -fints i1,i2,...,iN

-snsints i1,i2,...,iN	: set intersecting surface BC on surfaces i1,i2,...,iN
current equivalent	: -ints i1,i2,...,iN

-snsbc i1,i2,...,iN	: generate a SNS grid from surfaces i1,i2,...,iN
current equivalent	: -snsids i1,i2,...,iN

-setbc			: automatically find transparent and intersecting surfs
current equivalent	: msetbc=1

-setbc2			: automatically find trans/source and intersecting surfs
current equivalent	: msetbc=2

-brecs i1,i2,...,iN	: set reconnection flag on for surfaces i1,i2,...,iN
current equivalent	: -Rec_IDs i1,i2,...,iN

-set_vol_id		: set output file volume element id for each solid
current equivalent	: -vol_id or -vid

The option to specify the case name, input grid file or parameter file name
without a leading option flag has changed. Previous versions treated any name in
the argument list that did not correspond to a known option flag or parameter
specification as the name for the case name, input grid file name or parameter
file name.

[name]			: specify name for one of the following
			  case name to use as prefix for all files
			  or input grid file name
			  or input parameter file name

Current and future versions treat any name in the argument list that did not
correspond to a known option flag or parameter specification as the name for the
parameter file name.

[name]			: specify name for input parameter file name
================================================================================

Bugs Fixed:
-----------

* Added correct initialization of external routines for evaluation spacing.

* Corrected an issue with argument vector allocation that could cause
  failure after reading a TAGS, PSDATA, or SNSDATA file.

Known Issues
------------

* Anisotropic blending doesn't impact rebuild surfaces that
  intersect the BL region.


================================================================
aflr3 RELEASE NOTES: 10/30/13 RELEASE VERSION 13.6.9
================================================================

Enhancements/ Additions:
------------------------

* Added capability for transparent surfaces with free edges that
  intersect the BL region.

* Modified quad pyramid transition capability so that all quad
  faces are retained if mquadp=2.

* Modified final layer termination to include points that are on
  fixed constraint surfaces that intersect the BL region. This
  preserves hex element generation if the BL generating surface
  contains quad faces.

* Added minimum length scale for checking intersections with
  non-BL generating surfaces too account for constraining surfaces
  with high-aspect ratio faces that are near the BL region.

* Added capability to generate BL nodes along curves on continuous
  surfaces that intersect the BL region. Previous versions would
  generate BL nodes along curves if the curve was also a geometric
  edge (discontinuous surfaces).

Bugs Fixed:
-----------

* Corrected a possible memory leak after BL merge failure.

Known Issues
------------

* Anisotropic blending doesn't impact rebuild surfaces that
  intersect the BL region.


================================================================
aflr3 RELEASE NOTES: 09/26/13 RELEASE VERSION 13.4.5
================================================================

Enhancements/ Additions:
------------------------

* Modify algorithms for transparent surfaces used to generate
  a BL region in the field. Tria-faces at isolated corners (two
  edges have no face neighbor) are now automatically split in all
  in all cases.

* Removed quad/tria face restrictions on transparent surfaces
  used to generate a BL region in the field. At present quad
  faces may be used on any type of surface including transparent
  BL generating ones. Note however that hex elements will not
  be generated with -blc2 (mblelc=2) within BL regions attached
  to transparent surfaces such as wakes.

Bugs Fixed:
-----------

* 

Known Issues
------------

* Anisotropic blending doesn't impact rebuild surfaces that
  intersect the BL region.

================================================================
aflr3 RELEASE NOTES: 09/20/13 RELEASE VERSION 13.3.4
================================================================

Enhancements/ Additions:
------------------------

* 

Bugs Fixed:
-----------

* Corrected an error with resetting boundary conditions via a
  tags file (-tags option) whenever the input surface mesh
  included quad faces. Incorrect BCs were typically the result.

* Corrected errors associated with metric and transformation
  vector usage when length-scale reduction is active (mlsr=1).

Known Issues
------------

* Anisotropic blending doesn't impact rebuild surfaces that
  intersect the BL region.

* If their are quads on an embedded surface (that is not a
  source surface) then the mquadp=1 or 2 option to use quad
  face to pyramid element transitions in isotropic regions or
  for transition from hex to pyramid elements does not work.
  For example a wake sheet with attached BL region.

================================================================
aflr3 RELEASE NOTES: 09/16/13 RELEASE VERSION 13.2.4
================================================================

Enhancements/ Additions:
------------------------

* Added process to reconnect tria-faces derived from quad-faces
  on the surface at singular points (such as saddle points). This
  modifies the ordering for generating BL elements at such points
  and allows positive volume elements to be generated. The
  number of tria-faces that surround such singular points 
  should be minimized. For example the corner of a box has three
  surfaces and three trias (one for each surface) are optimal.

* Added a check of quad face quality on the outer interface of BL
  regions when hex element combination is selected (mblelc=2).
  Hex element formation is turned off locally if a quad face is
  higlhy curved or of low quality. The curvature is checked to
  insure that if the outer quad face is represented by tria faces
  the dihedral angle between them doesn't represent a discontinuity
  as defined by angbd. Quality is checked by insuring that the
  corner angles of the outer quad don't exceed angqbfq (new
  parameter with a default of 160 deg). If hex element formation
  is locally turned off then prism elements are formed instead.

* Added routine to reconnect tria-faces that were created from
  quad-faces on the surface mesh. This is used in BL generation
  to obtain optimal BL normals at singular points where a normal
  visible to all faces may not be possible.

* Added a process to reset the local length-scale of pyramid
  elements when quad to pyramid transition is active (mquadp=1,2).
  The local length-scale for pyramids is reset to the value for
  the quad base edge lengths. This increases the local length
  scale to a more appropriate value than the tria face edge
  lengths of pyramid elements and reduces the number of tet
  elements generated. However it will still produce more tet
  elements than with split quad faces (mquadp=0) due to limits
  on edge length growth. This option is controlled by the
  parameter flag mqpdf (default is 1). If mqpdf=2 a slight
  increase in the local length scale is used by including the
  length-scale of the pyramid base diagonal edge length. The
  option is always on.

Bugs Fixed:
-----------

* Corrected potential memory error in reallocation of space for
  pyramid faces when using pyramid transition from quad-faces.
* Corrected an initialization error with rebuild surfaces. This
  should have not impact on results as the parameter was not
  actually used.

* Corrected a memory issue and initialization error in
  transformation metric/vectors used for boundary recovery
  that could occur when pyramid transition from hex elements
  was used.

Known Issues
------------

* Anisotropic blending doesn't impact rebuild surfaces that
  intersect the BL region.

* If their are quads on an embedded surface (that is not a
  source surface) then the mquadp=1 or 2 option to use quad
  face to pyramid element transitions in isotropic regions or
  for transition from hex to pyramid elements does not work.
  For example a wake sheet with attached BL region.

================================================================
aflr3 RELEASE NOTES: 08/25/13 RELEASE VERSION 13.1.3
================================================================

Enhancements/ Additions:
------------------------

* Added option for metric space blending from BL regions into
  the isotropic tetrahedral region. The aspect ratio for the
  metric in the normal direction is based on the normal spacing
  of the last layer of elements generated in the BL region. The
  tangential aspect ratio is based on the surface anisotropy of
  the interface layer (usually very similar to that of the
  boundary surface). To activate this option use mmetblbl=2 and
  set cdfrsrc=1.0125. Use of metblbl=1 (linear interpolation)
  also works. However, the blending is very slow and anisotropy
  is carried far into the field. Similarly mmetblbl=2 and larger
  values of cdfrsrc > 1.0125 have slow blending. Note that
  cdfrsrc=1 is equivalent to mmetblbl=1. Changes in this
  behavior and performance of the blending are planned. At
  present the blending requires full field metric evaluations
  and is at least 2x slower.

* Added options and modified the process to better control
  quad-face to pyramid elements transition from hex elements
  in the BL regions. Previous versions of this option mquadp=1
  or 2 were not reliable. The current version should be stable
  and far more robust. A new parameter, msetqp, for controlling
  how the pyramid height is evaluated was added in addition to
  modifying the default value for the pyramid height multiplier
  such that cdfqp=0.5 by default. Their are three options for
  determining the pyramid height that is controlled by msetqp.
  If msetqp = 1 then the pyramid height is based solely on the
  base edge lengths. If msetqp = 2 then the pyramid height is
  based on the final layer BL normal spacing with limiting
  based on the pyramid base edge lenghts. If msetqp = 3 then
  the pyramid height is based solely on the final layer BL
  normal spacing. The default is msetqp=2. In general this
  provides the most suitable results. Height dependent upon
  the base of the pyramid also provides good results with
  a degradation in robustness as intersection checking between
  opposing pyramids is not done (only neighbors are checked).
  The last option that is based solely on the final layer BL
  normal spacing is most robust as that distance is checked
  for intersection during BL generation.

* Loci-CHEM code users that have found "convexity" test
  failures with hex elements that transition to tetrahedral
  elements with split face should use pyramid transition
  (mquadp=1 or 2) instead of slit faces.

* Modified the quality grid regeneration (QRG) phase after
  quality improvement (QI) with revised internal algorithms.
  The goal was a significant reduction in excessive CPU
  effort that could occur during this phase. Typically in
  such cases the improvement was minimal if any with
  considerable wasted effort. The option to use this method
  (mqrgen=1) is on by default and appears to be a far more
  robust process. To turn it off use mqrgen=0. The default
  maximum dihedral element angle that triggers this phase
  is set by angqrgen with a current default of 165. Lower
  value may increase the CPU effort required and higher
  values may degrade effectiveness.

* Added option to vary the height of pyramid elements created
  for quad transition. The height can be based on the base
  edge lengths, BL normal spacing (if applicable) with a minimum
  limit based on the base edge lengths, or BL normal spacing
  (if applicable) only.

* Added element quality checking for elements trapped between
  pyramid elements created for quad transition and their
  opposing neighbors.

* Added convexity test for checking of pyramid elements
  created for quad transition

* Modified length scale for checking of opposing nodes
  associated with pyramid elements created for quad transition.

* Modified quad face to pyramid transition process by turning
  off hex generation from quad faces that do not terminate with
  all face points on the same BL level.

* Modified the process that saves the last BL normal spacing
  values for use in BL blending by AFLR3.

* Modified checking of pyramid elements in quad face to pyramid
  transition routines. The minimum allowable distance between
  verticies at the top of adjacent pyramids was reduced to the
  minimum local edge length. This primarily has an impact with
  high-aspect-ratio surface meshes.

Bugs Fixed:
-----------

* Corrected a potential memory error during creation of pyramid
  elements for quad face to pyramid transition.

* Corrected a potential indexing error in the process that saves
  the last BL normal spacing values.

Known Issues
------------

* Anisotropic blending doesn't impact rebuild surfaces that
  intersect the BL region.

* if their are quads on an embedded surface (that is not a
  source surface) then the mquadp=1 or 2 option to use quad
  face to pyramid element transitions in isotropic regions or
  for transition from hex to pyramid elements does not work.
  For example a wake sheet with attached BL region.

================================================================
aflr3 RELEASE NOTES: 08/06/13 RELEASE VERSION 13.2.1
================================================================

Enhancements/ Additions:
------------------------

* Added capability for metric based evaluation of geometric
  quantities. Options associated with this capability will be
  described in an upcoming release.

* Modified checking of pyramid elements in quad face to pyramid
  transition routines. The minimum allowable distance between
  verticies at the top of adjacent pyramids was reduced to the
  minimum local edge length. This primarily has an impact with
  high-aspect-ratio surface meshes.

Bugs Fixed:
-----------

* Corrected an error with sources used in interpolation mode
  (msource=2). Using msource=2 with versions v19. and higher
  resulted in a failure at the start of the grid generation
  (GG) phase.

Known Issues
------------

* Anisotropic blending doesn't impact rebuild surfaces that
  intersect the BL region.

* With hex elements the top face can be inverted at one node
  (corner angle > 180). A check will be added in the future.

* With hex elements the mquadp=1 (isotropic) or 2 (BL cases)
  option to use quad face to pyramid element transitions in
  isotropic regions or for transition from hex to pyramid 
  elements does not work if their are quads on an embedded
  surface (that is not a source surface). For example a wake
  sheet with attached BL region.


================================================================
aflr3 RELEASE NOTES: 06/16/13 RELEASE VERSION 12.32.69
================================================================

Enhancements/ Additions:
------------------------

* Modified direct use of variables specified to be true "int"
  types (4 byte) to be compatible with global specification of
  INT_ types to be "long long int" (8 byte). Only libraries
  ug_io and ug3 required modification.

Bugs Fixed:
-----------

* Modified quad face to pyramid transition routines. Previous
  versions had potential issues with convex faces that could
  result merging of pyramid tip nodes that were OK. This often
  resulted in failure in AFLR due to a very distorted surface.
  This also could result in a failure due to not being able to
  insert all of the boundary nodes.

* Modified algorithm to determine Least-Squares surface normal
  vectors. Previous versions could produce erroneous results
  due to an ill-conditioned matrix. This could result in errors
  during evaluation of curved rebuild surfaces that intersect
  the BL region or early termination of BL generation at
  isolated surface nodes.

* Corrected a potential indexing error in the process that saves
  the last BL normal spacing values for use in BL blending by
  AFLR3.

* Corrected a memory issue with anisotropic blending. However,
  it is still not recommended for use as it is currently being
  significantly revised.

Known Issues
------------

* Anisotropic blending is BETA mode at best.

* With hex elements the top face can be inverted at one node
  (corner angle > 180). A check will be added in the future.

* With hex elements the mquadp=1 (isotropic) or 2 (BL cases)
  option to use quad face to pyramid element transitions in
  isotropic regions or for transition from hex to pyramid 
  elements does not work if their are quads on an embedded
  surface (that is not a source surface). For example a wake
  sheet with attached BL region.


================================================================
aflr3 RELEASE NOTES: 03/18/13 RELEASE VERSION 12.31.64
================================================================

Enhancements/ Additions:
------------------------

* Added modifications to allow for very long file names. Previous
  versions of AFLR are limited to file path names with about 100
  characters or less. The current version allows path names with
  up to about 1000 characters (500 on Windows).

Bugs Fixed:
-----------

* 

Known Issues
------------

* Anisotropic blending is BETA mode at best.

* With hex elements the top face can be inverted at one node
  (corner angle > 180). A check will be added in the future.

* With hex elements the mquadp=1 (isotropic) or 2 (BL cases)
  option to use quad face to pyramid element transitions in
  isotropic regions or for transition from hex to pyramid 
  elements does not work if their are quads on an embedded
  surface (that is not a source surface). For example a wake
  sheet with attached BL region.

================================================================
aflr3 RELEASE NOTES: 02/15/13 RELEASE VERSION 12.29.61
================================================================

Enhancements/ Additions:
------------------------

* Modified limitation on the number of BL layers that will be
  generated for a given boundary surface patch (of the same ID).
  This process prevents regions with coarse BL normal resolution
  from engulfing regions with fine resolution (see Release Notes
  comments for 12.22.44). It will not impact cases with constant
  or similar initial BL normal spacing. A new input parameter
  mnbllim can be used to turn this process on. It is on if
  mnbllim=1 and off if mnbllim=0. By default it is off. For cases
  with large variations in initial normal spacing it probably
  should be turned on. If the number of BL layers has been set on
  individual surface patches then this process will not override
  those selections.

* Added additional control for limiting the difference in number
  of BL layers between adjacent nodes to one (nbldiff=1), if
  specified, and if the number of BL layers for each surface ID
  patch is specified. If the number of layers is specified for
  one or more surface ID patches and if nbldiff=1 then the number
  of layers generated in a given BL grid generation step will
  automatically be reduced to one actual BL layer per step. This
  allows the normal limiting of BL layers between adjacent nodes
  to work at the junction between surface patches if they each
  have a different number of BL layers specified. Note that even
  with this change the number of BL layers difference between
  adjacent nodes can still exceed the limit set by nbldiff. This
  is possible only if multiple layers are being generated on
  each step (typically very close to the surface) and there is
  local termination of the BL generation. If cbldsm is reduced
  from the default of 0.5 then the region where multiple layers
  are generated is reduced. If cbldsm=0 then only one actual BL
  layer will be generated at a time and the limit set by nbldiff
  will always be fully met. The CPU time penalty with cbldsm=0
  can be a factor of two or more. However, this increase is only
  for the BL generation phase and all other aspects are the same.
  So the overall impact is highly case dependent.

* Added angle quality check to uv projected surface used for
  regenerating rebuild surfaces that intersect the BL region.
  The maximum angle allowed on the projected surface is
  angqprojuv with a default value of 175 degrees. If the initial
  surface has a triangular face with a corner angle above that
  then an error will be generated. Increasing the maximum 
  angle allowed, angqprojuv, may produce a valid mesh. However,
  it may not be usable and may also produce an error in the
  process that regenerates the surface. Any error in edge grid
  generation or in AFLR2 is the result of a problem with the
  rebuild surface.

* Modified search tolerance used in regenerating rebuild surfaces
  that intersect the BL region. With previous versions fatal
  errors in edge grid generation could be encountered due to
  points being outside the boundary edges for a particular
  surface by relatively small distance.

Bugs Fixed:
-----------

* Corrected an issue with topology of rebuild surfaces that
  intersect the BL region that could occur if some (not all)
  of the rebuild surfaces are periodic. The topology error
  typically resulted in fatal errors in boundary edge grid
  generation.

Known Issues
------------

* Anisotropic blending is BETA mode at best.

* With hex elements the top face can be inverted at one node
  (corner angle > 180). A check will be added in the future.

* With hex elements the mquadp=1 (isotropic) or 2 (BL cases)
  option to use quad face to pyramid element transitions in
  isotropic regions or for transition from hex to pyramid 
  elements does not work if their are quads on an embedded
  surface (that is not a source surface). For example a wake
  sheet with attached BL region.


================================================================
aflr3 RELEASE NOTES: 01/17/13 RELEASE VERSION 12.22.48
================================================================

Enhancements/ Additions:
------------------------

* Added smoothing algorithm to smooth out variations in BL normal
  spacing if there are fixed/constrained surfaces that intersect
  the BL region. New input parameters that control the smoothing
  include mdsblfisf, nblsmthlisf, and dsblfisfmax.

Bugs Fixed:
-----------

* 

Known Issues
------------

* Anisotropic blending is BETA mode at best.

* With hex elements the top face can be inverted at one node
  (corner angle > 180). A check will be added in the future.

* With hex elements the mquadp=1 (isotropic) or 2 (BL cases)
  option to use quad face to pyramid element transitions in
  isotropic regions or for transition from hex to pyramid 
  elements does not work if their are quads on an embedded
  surface (that is not a source surface). For example a wake
  sheet with attached BL region.

Bugs Fixed:
-----------

* 

================================================================
aflr2c RELEASE NOTES: 10/10/20 RELEASE VERSION 9.13.13
================================================================

Enhancements/ Additions:
------------------------

* Modified Message_Flag (mmsg) usage for values of 0 (no output)
  and -1 (minimal output).

Bugs Fixed:
-----------

* 

================================================================
aflr2c RELEASE NOTES: 11/26/18 RELEASE VERSION 9.14.4
================================================================

Enhancements/ Additions:
------------------------

* 

Bugs Fixed:
-----------

* Added check to quad formation routine aflr2_quad to insure that
  the edge BC flag is not used unless it is allocated.

================================================================
aflr2c RELEASE NOTES: 07/10/18 RELEASE VERSION 9.14.3
================================================================

Enhancements/ Additions:
------------------------

* Changed mw_bg_func to mw_func.

* Added mw_func_type for UGRID/SFUNC and MESHB/SOLB file types.

Bugs Fixed:
-----------

* 

================================================================
aflr2c RELEASE NOTES: 05/03/18 RELEASE VERSION 9.13.1
================================================================

Enhancements/ Additions:
------------------------

* 

Bugs Fixed:
-----------

* Corrected initialization errors during edge grid regeneration
  with a background mesh or use of an external evaluation function.

================================================================
aflr2c RELEASE NOTES: 11/16/17 RELEASE VERSION 9.13.26
================================================================

Enhancements/ Additions:
------------------------

* Changed method to estimate the number of tria-faces that will
  be generated.

Bugs Fixed:
-----------

================================================================
aflr2c RELEASE NOTES: 08/13/17 RELEASE VERSION 9.11.20
================================================================

Enhancements/ Additions:
------------------------

* Changed fmin/fmax to MIN/MAX.

* Added capability to skip all output when aflr3_grid_generator_i
  is called directly.

Bugs Fixed:
-----------


================================================================
aflr2c RELEASE NOTES: 06/21/17 RELEASE VERSION 9.10.22
================================================================

Enhancements/ Additions:
------------------------

* Added boundary edge grid regeneration for external spacing
  evaluation functions.

* Updated test evaluation function.

* Added lm7 MESH library with full 64-bit int support.

* Modified parameters for edge length multiplier and nearby node
  factor. New parameters are cdff2 and cdfn2. Removed parameters
  nadvpit and cdffinl.

Bugs Fixed:
-----------

* 

================================================================
aflr2c RELEASE NOTES: 05/04/17 RELEASE VERSION 9.6.16
================================================================

Enhancements/ Additions:
------------------------

* 

Bugs Fixed:
-----------

* Correct metric flag check errors.

================================================================
aflr2c RELEASE NOTES: 04/27/17 RELEASE VERSION 9.5.16
================================================================

Enhancements/ Additions:
------------------------

* Changes for compatibility with 64-bit integers.

* Reset source data on return in case none are accepted in which
  case the source data is free'd and the number of sources is
  set to 0.

* Modified checking of source nodes to reduce the minimum allowable
  distance between source nodes and boundaries (changed MIN to MAX).

Bugs Fixed:
-----------

* 

================================================================
aflr2c RELEASE NOTES: 12/16/16 RELEASE VERSION 9.4.9
================================================================

Enhancements/ Additions:
------------------------

* Moved dftr2_qtb_chk, dftr2_qtb_chk_n, and dftr2_qtb_eval to
  AFLR2C_LIB.

* Made dftr2_src_* routines external and moved them to AFLR2C_LIB.

Bugs Fixed:
-----------

* 

================================================================
aflr2c RELEASE NOTES: 12/16/16 RELEASE VERSION 9.3.8
================================================================

Enhancements/ Additions:
------------------------

* Changes for compatibility with revised DFTR2 & QTB LIBs.

Bugs Fixed:
-----------

* 

================================================================
aflr2c RELEASE NOTES: 10/04/16 RELEASE VERSION 9.2.6
================================================================

Enhancements/ Additions:
------------------------

* Complete revision of interior core mesh (ICE) overall approach.
  If this option is specified then the new version will generate
  a Cartesian core with isotropically varying quad size dependent
  upon a background mesh. The main program will automatically
  generate the background mesh if one is not input. The resulting
  mesh has a minimal region of truly unstructured trias and/or
  quads.

* Changes for compatibility with revised glue routine in UG2_LIB
  used with Cartesian interior core cases.

Bugs Fixed:
-----------

* 

================================================================
aflr2c RELEASE NOTES: 09/10/16 RELEASE VERSION 8.7.27
================================================================

Enhancements/ Additions:
------------------------

* Added option flag -backgen to generate and output a background
  mesh (and function file) from the input surface mesh.

* Added option flag -backgen2 to generate a background mesh
  mesh and length-scale data from the input surface mesh and
  then use the background mesh to generate the final volume mesh.
  In the future this will become the default mode and pure
  interpolation will be removed.

* Added background mesh element neighbor connectivity to API
  for aflr2_grid_generator.

Bugs Fixed:
-----------

* 

================================================================
aflr2c RELEASE NOTES: 08/30/16 RELEASE VERSION 8.6.25
================================================================

Enhancements/ Additions:
------------------------

* Changes for compatibility with revised UG, QTB and ICE2 libraries.

Bugs Fixed:
-----------

* 

================================================================
aflr2c RELEASE NOTES: 03/02/16 RELEASE VERSION 8.6.19
================================================================

Enhancements/ Additions:
------------------------

* Combined AFLR2C Lib and AFLR2C_API Lib. AFLR2C_API Lib is no
  longer separate or used.

* Minor syntax change in if check.

Bugs Fixed:
-----------

* 

================================================================
aflr2c RELEASE NOTES: 12/02/15 RELEASE VERSION 8.5.13
================================================================

Enhancements/ Additions:
------------------------

* Added metric normal spacing specification that is compatible
  with AFLR3 metric BL blending.

* Added input parameters dsdef (metric initial normal spacing),
  mmetds (metric initial normal spacing flag), and removed the
  old input parameter trds that was used to set the initial
  normal spacing.

* Modified metric point placement processes for metric blending
  mode with mmetds=1.

* Removed direct use of fopen and fclose.

* Modified process for determining if elements are active when
  metric mode is on.

* Turned of angle quality check when determining if elements are
  active.

Bugs Fixed:
-----------

* Correct error in some calls to routine for metric averaging.

* Correct a memory allocation error when reading in an existing
  complete mesh for additional mesh generation.

================================================================
aflr2c RELEASE NOTES: 09/18/15 RELEASE VERSION 8.3.7
================================================================

Enhancements/ Additions:
------------------------

* Added full metric tensor capability.

Bugs Fixed:
-----------

* 

================================================================
aflr2c RELEASE NOTES: 07/13/15 RELEASE VERSION 7.16.66
================================================================

Enhancements/ Additions:
------------------------

* Modified 2D interior core mesh code for improved quality and
  more robust group identification.

Bugs Fixed:
-----------

* 

================================================================
aflr2c RELEASE NOTES: 06/28/15 RELEASE VERSION 7.16.77
================================================================

Enhancements/ Additions:
------------------------

* Removed transformation vector capability.

Bugs Fixed:
-----------

* Corrected incorrect script in examples that used the background
  grid file as name *.BG.* instead of the correct *.back.*.

================================================================
aflr2c RELEASE NOTES: 02/28/15 RELEASE VERSION 7.12.51
================================================================

Enhancements/ Additions:
------------------------

* Added API for metric capability.

* Added complete background grid capability. If a background grid
  is input then it is used for all length scale evaluations. No
  input options are required with a background grid. The executable
  will search for files named input_case_name.back.* for the
  background volume grid and function file. If they exist they
  will be read and data passed to AFLR2. Internal options are set
  if a background grid is passed to AFLR2.

Bugs Fixed:
-----------

* 

================================================================
aflr2c RELEASE NOTES: 01/20/15 RELEASE VERSION 7.9.31
================================================================

Enhancements/ Additions:
------------------------

* Added capability to generate a 2D interior core mesh using the
  ICE2 library.

* Modified source checks for compatibility with QTB library.

* Revised error messages when multiple unconnected domains are
  found.

Bugs Fixed:
-----------

* Corrected incorrect free of work structure when a failure
  occurred during initial grid generation.

================================================================
aflr2c RELEASE NOTES: 06/23/14 RELEASE VERSION 7.8.28
================================================================

Enhancements/ Additions:
------------------------

* Modified determination of the length scale for new points to
  reduce the impact of growth limiting (based on the edge advanced
  from). The previous method allowed the length scale to become
  significantly smaller than that determined from interpolation.

Bugs Fixed:
-----------

* Corrected a potential uninitialized memory access during final
  elimination of isolated tria faces on boundary corners.

================================================================
aflr2c RELEASE NOTES: 06/05/14 RELEASE VERSION 7.7.27
================================================================

Enhancements/ Additions:
------------------------

* Convert to new XPLT2 lib API.

* Added capability for external routines to all aflr2 and have
  minimal output generated.

Bugs Fixed:
-----------

* 

================================================================
aflr2c RELEASE NOTES: 05/20/14 RELEASE VERSION 7.7.25
================================================================

Enhancements/ Additions:
------------------------

* Added API argument to specify a method when using an external
  sizing function. The method is specified using the mext_eval
  input parameter. Note that the built-in external sizing
  function is intended for testing mode only and not useful for
  real applications.

Bugs Fixed:
-----------

* Corrected initialization of MESH type files. They were not
  correctly enabled in previous versions.

================================================================
aflr2c RELEASE NOTES: 05/10/14 RELEASE VERSION 7.6.23
================================================================

Enhancements/ Additions:
------------------------

* Added new ARG input argument file type (*.arg) to replace the
  old PARAM input parameter file type (*.par). Old PARAM parameter
  files can still be input. In all cases an argument file is
  saved for re-running with the same options if the program runs to
  successful completion. See the documentation for more information
  on argument files.

Bugs Fixed:
-----------

* 

================================================================
aflr2c RELEASE NOTES: 04/27/14 RELEASE VERSION 7.5.20
================================================================

Enhancements/ Additions:
------------------------

* Added capability to use program executable arguments that 
  individually are of any length (subject to system limits on the
  overall argument list length of 262144 bytes or characters). If
  they are set internally then there is no limit (other than
  overall system memory limits). This impacts primarily setting
  of input parameter vectors, e.g. ID lists for BCs. Note that
  pathnames are still subject to system limits.

* Changed default on use of an external sizing function. This
  option is now always available. Although, it is only useful 
  for testing, unless an external function is created and 
  the executable is compiled with it linked in.

Bugs Fixed:
-----------

* Corrected error in reading UG input parameter files.
  Previous 7.x.x versions did not actually set or use any
  of the input parameters read.

* Remove uninitialized XPLT flag mxplt.

* Correct potential uninitialized variable use. This change 
  primarily impacts use of an external sizing function.

================================================================
aflr2c RELEASE NOTES: 03/15/14 RELEASE VERSION 7.2.13
================================================================

Enhancements/ Additions:
------------------------

* Modified isolated edge grid removal algorithm for determining
  which element edges to split.

Bugs Fixed:
-----------

* Correct list of elements to consider for reconnection during
  isolated edge grid removal.

================================================================
aflr2c RELEASE NOTES: 02/23/14 RELEASE VERSION 7.1.13
================================================================

Enhancements/ Additions:
------------------------

* Convert to new ug parameter structure scheme and eliminate
  use of Error_Message.

Bugs Fixed:
-----------

* 

================================================================
aflr2c RELEASE NOTES: 08/15/13 RELEASE VERSION 6.12.13
================================================================

Enhancements/ Additions:
------------------------

* 

Bugs Fixed:
-----------

* Corrected errors in algorithm to split isolated interior edges.

* Corrected errors in algorithm to check node placement near
  boundaries.

Known Issues
------------


================================================================
aflr2c RELEASE NOTES: 08/01/13 RELEASE VERSION 6.11.12
================================================================

Enhancements/ Additions:
------------------------

* Updated character string declarations.

* Added check before deleting candidate points that gives priority
  to advancing-point candidates generated for quad-faces.

Bugs Fixed:
-----------

* Corrected minor uninitialized memory read error.

Known Issues
------------


================================================================
aflr2c RELEASE NOTES: 03/20/13 RELEASE VERSION 6.11.8
================================================================

Enhancements/ Additions:
------------------------

* Updated character string declarations.

* Added check before deleting candidate points that gives priority
  to advancing-point candidates generated for quad-faces.

Bugs Fixed:
-----------

* 

Known Issues
------------


================================================================
aflr2c RELEASE NOTES: 01/17/13 RELEASE VERSION 6.9.7
================================================================

Enhancements/ Additions:
------------------------

* Updated CMake files.

Bugs Fixed:
-----------

* 

Known Issues
------------

